import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["children", "defaultOpenedTabs", "onToggleTab", "openedTabs", "withAutoClose"];
import { useEffect, useState, Children } from 'react';
import PropTypes from 'prop-types';
import Tab from './Tab/index.js';
import { BASE_CLASS } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";

var MoleculeAccordion = function MoleculeAccordion(_ref) {
  var children = _ref.children,
      _ref$defaultOpenedTab = _ref.defaultOpenedTabs,
      defaultOpenedTabs = _ref$defaultOpenedTab === void 0 ? [] : _ref$defaultOpenedTab,
      _ref$onToggleTab = _ref.onToggleTab,
      onToggleTab = _ref$onToggleTab === void 0 ? function () {} : _ref$onToggleTab,
      openedTabs = _ref.openedTabs,
      withAutoClose = _ref.withAutoClose,
      tabProps = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(openedTabs || defaultOpenedTabs),
      openedTabsState = _useState[0],
      setOpenedTabsState = _useState[1];

  useEffect(function () {
    if (openedTabs !== undefined) {
      if (openedTabsState.length !== (openedTabs == null ? void 0 : openedTabs.length)) {
        setOpenedTabsState(openedTabs);
      } else if ((openedTabs == null ? void 0 : openedTabs.sort().join('')) !== openedTabsState.sort().join('')) {
        setOpenedTabsState(openedTabs);
      }
    }
  }, [openedTabs, openedTabsState]);

  var _handleOnToggle = function _handleOnToggle(index) {
    return function (event) {
      var newOpenedTabsState = [];

      if (withAutoClose) {
        newOpenedTabsState = openedTabsState.includes(index) ? [] : [index];
      } else {
        newOpenedTabsState = openedTabsState.includes(index) ? openedTabsState.filter(function (tabIndex) {
          return tabIndex !== index;
        }) : [].concat(openedTabsState, [index]).sort();
      }

      onToggleTab(event, {
        index: index,
        openedTabs: [].concat(newOpenedTabsState)
      });

      if (openedTabs === undefined) {
        setOpenedTabsState([].concat(newOpenedTabsState));
      }
    };
  };

  return /*#__PURE__*/_jsx("div", {
    className: BASE_CLASS,
    role: "tablist",
    children: Children.map(children, function (child, index) {
      return /*#__PURE__*/_jsx(Tab, _extends({
        isOpen: openedTabsState.includes(index),
        onToggle: _handleOnToggle(index),
        title: child.props.label
      }, tabProps, {
        children: child.props.children
      }), index);
    })
  });
};

MoleculeAccordion.displayName = 'MoleculeAccordion';
MoleculeAccordion.defaultProps = {
  withAutoClose: true
};
export default MoleculeAccordion;